import 'package:when_extension/when_extension.dart';
import 'package:test/test.dart';

void main() {
  group('String.when', () {
    test('Match test', () {
      final s = 'test';
      final result = s.when({
        'wrong': () => 1,
        'test': () => 2,
      });
      expect(result, 2);
    });

    test('any', () {
      final s = 'aaa';
      final result = s.when(
        {
          'wrong': () => 1,
          'test': () => 2,
        },
        any: () => 3,
      );
      expect(result, 3);
    });

    test('no match', () {
      final s = 'aaa';
      expect(
          () => s.when(
                {
                  'wrong': () => 1,
                  'test': () => 2,
                },
              ),
          throwsException);
    });
  });
}
